# Crypttool Docs

Crypttool is an open source utility to de- and encrypt files using a symmetrical key. 
The emphasis is on using simple to use web interface to allow anyone to use symmetric encryption for e.g. Email 
attachments without installing additional software.

The application runs entirely in the Browser and does not send any Data to the webserver beyond the main requests.

## Usage:

### 1. Password Generation
The Password field is populated randomly on every page load using the [getRandomValues](https://developer.mozilla.org/en-US/docs/Web/API/Crypto/getRandomValues) 
function of the web browsers crypto API. Because this application (currently) does not use any cookies, it does not 
persist the password across sessions.  
If you want to use your own password, you can supply it by entering it in the password field and clicking "Update". Be
careful when using a password that isn't truly randomly created, since the whole cryptography of this application is
built on this string. Thus it is strongly advised to use a randomly generated password or passphrase.

### 2. Encrypting a File
To encrypt a file, you just need to drag it to the field containing the "Encrypt" button and press
the "Encrypt button". Your browser will now encrypt the file and "download" it. The Encryption is handled using the
[encrypt](https://developer.mozilla.org/en-US/docs/Web/API/SubtleCrypto/encrypt) method of the 
[SubtleCrypto](https://developer.mozilla.org/en-US/docs/Web/API/SubtleCrypto) API.

### 3. Decrypting a File
To decrypt a file, first enter the password that was used to encrypt it in the "Password" field and click "Update".
Then, drag the encrypted file to the field containing the "Decrypt" button.
After pressing the "Decrypt" button, your browser should decrypt the file using the [decrypt](https://developer.mozilla.org/en-US/docs/Web/API/SubtleCrypto/decrypt)
method of the SubtleCrypto API and "download" the cleartext file.
